REM read map files
REM print out hex identifiers and column and row number
REM
REM 11/7/97  Bill Haering
REM

DIM map%(4910, 5)
REM REM DIM map%(8000, 3)
DIM chread%(37)
DIM ternam$(37)
DIM tersym$(37)
DIM lineof%(16)
DIM rodtst%(6)
DIM rodspc$(6)
DIM rodchk%(6)
DIM names$(260)
DIM rep%(260)
DIM compres%(260)
DIM newnam$(260)


FOR i% = 1 TO 260
  rep%(i%) = 0
  compres%(i%) = 0
NEXT i%


rodtst%(1) = 1
rodtst%(2) = 2
rodtst%(3) = 8
rodtst%(4) = 16
rodtst%(5) = 32
rodtst%(6) = 128


rodspc$(1) = "A"
rodspc$(2) = "B"
rodspc$(3) = "C"
rodspc$(4) = "D"
rodspc$(5) = "E"
rodspc$(6) = "F"

FOR i% = 1 TO 16
  lineof%(i) = 0
NEXT i%

REM
REM  breakdown of entries
REM   new  old
REM    5    1 = name number or ff
REM    -    2 = city port (00) other 7f
REM    -    3 = 00 (uasble) ff (unusable) but doesn't seem to matter
REM    4    4 = road code (same as in PG)
REM    1    5 = 2nd byte of tile address
REM    2    6 = 1st byte (pallette) of tile address
REM    3    7 = terrain
REM    -    8 = owner

ternam$(1) = "Inland City"
ternam$(2) = "Coastal City"
ternam$(3) = "Dirt Road"
ternam$(4) = "Paved Road"
ternam$(5) = "Clear"
ternam$(6) = "Forest"
ternam$(7) = "Kunai"
ternam$(8) = "Regular Jungle"
ternam$(9) = "Dense Jungle"
ternam$(10) = "Palm Trees"
ternam$(11) = "Bamboo"
ternam$(12) = "Bocage"
ternam$(13) = "Paved Road"
ternam$(14) = "Agriculture"
ternam$(15) = "Rice Paddy-In Season"
ternam$(16) = "Rice Paddy-Drained"
ternam$(17) = "Desert"
ternam$(18) = "Oasis"
ternam$(19) = "Swamp"
ternam$(20) = "Rough"
ternam$(21) = "Volcanic"
ternam$(22) = "Hill"
ternam$(23) = "Mountain"
ternam$(24) = "Escarpment"
ternam$(25) = "River"
ternam$(26) = "Beach"
ternam$(27) = "Pier"
ternam$(28) = "Seawall"
ternam$(29) = "Tetrahedron"
ternam$(30) = "Reef"
ternam$(31) = "Coast"
ternam$(32) = "Deep Ocean"
ternam$(33) = "Jungle Path"
ternam$(34) = "Dirt Airfield"
ternam$(35) = "Paved Airfield"
ternam$(36) = "Fortification"
ternam$(37) = "Oilfield"

FOR i% = 1 TO 37
  tersym$(i%) = HEX$(i% - 1)
  IF LEN(tersym$(i%)) = 1 THEN
    tersym$(i%) = " " + tersym$(i%)
   ELSE
  END IF
NEXT i%



CLS 0


CHDIR "c:\mapedit"
FILES "*.map"
INPUT "input map file name (- .map) "; filin$
file$ = filin$ + ".map"
filtst$ = "s" + filin$ + ".tst"


REM
REM read in tst file
REM
OPEN filtst$ FOR INPUT ACCESS READ AS #3
REM

FOR i% = 1 TO 300
 IF EOF(3) THEN
   GOTO 771
  ELSE
   itst% = i%
   LINE INPUT #3, names$(i%)
 END IF
NEXT i%
PRINT " over 300 entries"
GOTO 990

771 dummy = 0
REM PRINT itst%; " entries"
REM PRINT " last entry "; names$(itst%)

FOR i% = 1 TO itst%
  IF rep%(i%) = 0 THEN
    ELSE
     GOTO 768
  END IF
  chk$ = names$(i%)
  FOR j% = i% + 1 TO itst%
    IF names$(j%) = chk$ THEN
REM      PRINT #6, " repeat "; i%; " "; j%
      rep%(j%) = i%
     ELSE
    END IF
  NEXT j%
  REM PRINT i%
768 NEXT i%

irepct% = 0
FOR i% = 1 TO itst%

  IF rep%(i%) = 0 THEN
     irepct% = irepct% + 1
     newnam$(irepct%) = names$(i%)
     compres%(i%) = irepct%
 REM    PRINT i%; "   "; names$(i%)
   ELSE
  END IF
NEXT i%

CLOSE #3



REM
REM read in map
REM
OPEN file$ FOR BINARY ACCESS READ AS #2
REM
REM read in rows and column numbers

i% = 0
a$ = " "
GET #2, , a$
col% = ASC(a$)
a$ = " "
GET #2, , a$
a$ = " "
GET #2, , a$
row% = ASC(a$)
a$ = " "
GET #2, , a$

istp% = row% * col%
FOR i% = 1 TO istp%
REM FOR i% = 1 TO 2
 FOR j% = 1 TO 37
  a$ = " "
  GET #2, , a$
  chread%(j%) = ASC(a$)
NEXT j%
REM map%(i%, 1) = chread%(1)
REM map%(i%, 2) = chread%(2)
REM map%(i%, 3) = chread%(5)
REM map%(i%, 4) = chread%(12)
REM map%(i%, 5) = chread%(13)
REM map%(i%, 6) = chread%(15)
REM map%(i%, 7) = chread%(16)
REM map%(i%, 8) = chread%(17)
map%(i%, 1) = chread%(13)
map%(i%, 2) = chread%(15)
map%(i%, 3) = chread%(16)
map%(i%, 4) = chread%(12)
map%(i%, 5) = chread%(1)


NEXT i%
CLOSE #2
REM

REM change placename designations

FOR i% = 1 TO istp%

  IF map%(i%, 5) = 255 THEN
    GOTO 978
   ELSE
  END IF

  IF map%(i%, 5) >= itst% THEN
    PRINT "  "
    PRINT " for index "; i%; " "
    PRINT " place name "; map%(i%, 5) + 1; " is called for"
    PRINT " but there are only "; itst%; " placenames"
    INPUT "hit return to set to no placename and continue "; istal$
    map%(i%, 5) = 255
    GOTO 978
   ELSE
  END IF


  IF rep%(map%(i%, 5) + 1) = 0 THEN
    temp% = map%(i%, 5) + 1
   ELSE
    temp% = rep%(map%(i%, 5) + 1)
  END IF
REM   PRINT " "
REM   PRINT " map%(i%,5) "; map%(i%, 5); "  rep  "; rep%(map%(i%, 5) + 1)
  map%(i%, 5) = compres%(temp%) - 1
REM  PRINT "new map%(i%,5) "; map%(i%, 5)
REM  INPUT "hit return to continue"; istal$
978 NEXT i%




911 CLS 0

PRINT "Valid Enrties  Columns ( 0 -"; col% - 1; ")"; "   Rows ( 0 -"; row% - 1; ")"
PRINT " "
INPUT "input hex to edit  col#,row#  (D)  "; colnum%, rownum%
GOSUB Mapindx
prt1$ = HEX$(map%(indx%, 2))
prt2$ = HEX$(map%(indx%, 1))
prt3$ = ternam$(map%(indx%, 3) + 1)
roadin% = map%(indx%, 4)
IF roadin% = 0 THEN
  prt4$ = "(no road)"
 ELSE
  GOSUB Road
  prt4$ = let$
END IF

IF map%(indx%, 5) = 255 THEN
  prt5$ = "(no PlaceName)"
 ELSE
  GOSUB Road
  prt5$ = newnam$(map%(indx%, 5) + 1)
END IF



PRINT " "
PRINT "Icon byte #2    Icon byte #1       Terrain"
PRINT "     "; prt1$; "               "; prt2$; "             "; prt3$
PRINT " "
PRINT "Road Designation     Placename"
PRINT USING "\       \             \                          \"; prt4$; prt5$
REM                                 3456789 123456789 12345678
PRINT " "
PRINT " "
PRINT "options  1-diff col/row     2-change map icon    3-change terrain "
INPUT "         4-change road      5-placename change   6-end            "; idec%

in% = 1
ON idec% GOTO 911, 200, 300, 400, 500, 801

REM icon
200 PRINT " "
INPUT "inpt new icon address   Byte#2,Byte#1  (H)  ", b2$, b1$
PRINT " "
PRINT "confirmation        Byte#2    Byte#1"
PRINT "     old             "; prt1$; "    "; prt2$
PRINT "     new             "; b2$; "    "; b1$
INPUT " Accept Change   Y/N ?  ", acpt$
IF LEFT$(acpt$, 1) = "Y" OR LEFT$(acpt$, 1) = "y" THEN
  hexin$ = b2$
  GOSUB Hexprt
  IF errret% = -1 THEN
    PRINT "error in input"
    INPUT "hit return to continue"; stal$
    GOTO 200
   ELSE
    new2% = iprt%
  END IF

  hexin$ = b1$
  GOSUB Hexprt
  IF errret% = -1 THEN
    PRINT "error in input"
    INPUT "hit return to continue"; stal$
    GOTO 200
   ELSE
    new1% = iprt%
  END IF

 map%(indx%, 2) = new2%
 map%(indx%, 1) = new1%

 ELSE
  GOTO 200
END IF
GOTO 911

REM terrain
300 CLS 0
PRINT "valid entries"
FOR i% = 1 TO 11
  PRINT USING "\\  \            \    \\  \                  \    \\  \            \"; tersym$(i%); ternam$(i%); tersym$(i% + 13); ternam$(i% + 13); tersym$(i% + 26); ternam$(i% + 26)
NEXT i%
FOR i% = 12 TO 13
  PRINT USING "\\  \            \    \\  \                  \"; tersym$(i%); ternam$(i%); tersym$(i% + 13); ternam$(i% + 13)
REM  PRINT tersym$(i%); " -"; ternam$(i%); "   "; tersym$(i% + 13); " -"; ternam$(i% + 13)
NEXT i%
INPUT "input new terrain code  (H)  ", tr$
hexin$ = tr$
GOSUB Hexprt
IF errret% = -1 THEN
  PRINT "error in input"
  INPUT "hit return to continue"; stal$
  GOTO 300
 ELSE
END IF

PRINT " "
PRINT "confirmation        terrain   "
PRINT "     old             "; prt3$
PRINT "     new             "; ternam$(iprt% + 1)
INPUT " Accept Change   Y/N ?  ", acpt$
IF LEFT$(acpt$, 1) = "Y" OR LEFT$(acpt$, 1) = "y" THEN
  map%(indx%, 3) = iprt%
 ELSE
  GOTO 300
END IF
GOTO 911

REM road
400  roadin% = map%(indx%, 4)
GOSUB Road
CLS 0
PRINT " "
REM PRINT map%(indx%, 4); "   road designation "; let$
PRINT "         A            Roads are designated by the hex sides"
PRINT "      ______          that they cross.  For specifying roads  "
PRINT "  F /        \ B      the picture on the left serves as the"
PRINT "   /          \       reference.  A series of letters shows"
PRINT "  /            \      the hex sides that roads pass through."
PRINT "  \            /      Valid entries include no entry (noroad),"
PRINT " E \          / C     through   ABCDEF."
PRINT "    \ ______ /  "
PRINT "                      Current Designation   => "; let$
IF in% = 1 THEN
INPUT "         D            Input New Designation  "; rodinp$
 in% = 0
 rodinp$ = UCASE$(rodinp$)
 GOTO 400
 ELSE
PRINT "         D            New Designation       => "; rodinp$
INPUT "                        confirm choice   y/n "; iconf$
  IF iconf$ = "y" OR iconf$ = "Y" THEN
    GOSUB Roadec
    IF errret% = 0 THEN
     ELSE
     in% = 1
      GOTO 400
    END IF
    map%(indx%, 4) = irdnum%
    GOTO 911
   ELSE
    in% = 1
    GOTO 400
  END IF
END IF

REM PRINT " "
REM INPUT "hit return to continue "; istal$
GOTO 911

REM placenames
500 GOSUB Place
GOTO 911

801 filmap$ = "mapedit.map"
OPEN filmap$ FOR BINARY ACCESS WRITE AS #6
killen = LOF(6)
IF killen > 0 THEN
  CLOSE #6
  KILL filmap$
  OPEN filmap$ FOR BINARY ACCESS WRITE AS #6
 ELSE
END IF

filtxt$ = "smapedit.tst"
OPEN filtxt$ FOR OUTPUT ACCESS WRITE AS #7
killen = LOF(7)
IF killen > 0 THEN
  CLOSE #7
  KILL filtxt$
  OPEN filtxt$ FOR BINARY ACCESS WRITE AS #7
 ELSE
END IF

FOR i% = 1 TO irepct%
 PRINT #7, newnam$(i%)
NEXT i%
CLOSE #7



REM
REM read in map
REM
OPEN file$ FOR BINARY ACCESS READ AS #2
REM
REM read in rows and column numbers

i% = 0
a$ = " "
GET #2, , a$
PUT #6, , a$
col% = ASC(a$)
a$ = " "
GET #2, , a$
PUT #6, , a$
a$ = " "
GET #2, , a$
PUT #6, , a$
row% = ASC(a$)
a$ = " "
GET #2, , a$
PUT #6, , a$

istp% = row% * col%
FOR i% = 1 TO istp%
 FOR j% = 1 TO 37
  a$ = " "
  GET #2, , a$
  chread%(j%) = ASC(a$)
 NEXT j%
  chread%(13) = map%(i%, 1)
  chread%(15) = map%(i%, 2)
  chread%(16) = map%(i%, 3)
  chread%(12) = map%(i%, 4)
  chread%(1) = map%(i%, 5)
REM  map%(i%, 5) = chread%(1)
  lineof%(chread%(15) + 1) = 1
  IF chread%(1) = 255 THEN
    chread%(2) = 127
   ELSE
    chread%(2) = 0
  END IF
 FOR j% = 1 TO 37
  IF chread%(j%) < 0 OR chread% > 255 THEN
    PRINT " "
    PRINT "invalid entry  j%, chread%(j%)  "; j%; " "; chread%(j%)
    PRINT " i = "; i%
    INPUT "hit return to set to zero and continue "; istal$
    chread%(j%) = 0
   ELSE
  END IF
  a$ = CHR$(chread%(j%))
  PUT #6, , a$
 NEXT j%
NEXT i%

FOR i% = 1 TO 101
  IF EOF(2) THEN
    GOTO 989
   ELSE
  END IF

  a$ = " "
  GET #2, , a$
  IF i% < 17 THEN
    a$ = CHR$(lineof%(i%))
   ELSE
  END IF

  PUT #6, , a$
NEXT i%

989 CLOSE #2
CLOSE #6



990 CLOSE
INPUT "hit return to continue "; dumm$
SYSTEM

Hexprt:
IF LEN(hexin$) = 1 THEN
  hexent$ = hexin$
  GOSUB Hexdec
  iprt% = numret%
 ELSE
  hexent$ = RIGHT$(hexin$, 1)
  GOSUB Hexdec
  iprt% = numret%
  hexent$ = LEFT$(hexin$, 1)
  GOSUB Hexdec
  iprt% = iprt% + numret% * 16
END IF
REM PRINT "hex entry  "; hexin$; "  equals  "; iprt%; "  in decimal"
IF iprt% > -1 AND iprt < 256 THEN
  errret% = 0
 ELSE
  errret% = -1
END IF
RETURN


Mapindx:
indx% = rownum% * col% + colnum% + 1
RETURN



Hexdec:
hexent$ = UCASE$(hexent$)
codent% = ASC(hexent$)
numret% = -1
IF (codent% < 65 OR codent% > 70) AND (codent% < 48 OR codent% > 57) THEN
  PRINT "entry "; hexent$; " is not a valid hex number"
  RETURN
 ELSE
  IF (codent% > 64 AND codent% < 71) THEN
    numret% = codent% - 55
   ELSE
    numret% = codent% - 48
  END IF
END IF
RETURN

Road:
FOR ij% = 1 TO 6
  rodchk%(ij%) = 0
NEXT ij%

FOR ij% = 1 TO 6
  IF roadin% >= rodtst%(7 - ij%) THEN
    rodchk%(7 - ij%) = 1
    roadin% = roadin% - rodtst%(7 - ij%)
   ELSE
  END IF
NEXT ij%

let$ = ""
FOR ij% = 1 TO 6
  IF rodchk%(ij%) = 1 THEN
    let$ = let$ + rodspc$(ij%)
   ELSE
  END IF
NEXT ij%

RETURN


Roadec:
ikey% = LEN(rodinp$)
errret% = 0
REM PRINT " ikey "; ikey%
irdnum% = 0
IF ikey% = 0 THEN
   RETURN
  ELSE
   FOR ij% = 1 TO ikey%
     tstlet$ = MID$(rodinp$, ij%, 1)
     tstlt% = ASC(tstlet$)
     IF tstlt% < 65 OR tstlt% > 70 THEN
       PRINT "error in input string  "; tstlet$
       INPUT "hit reurn to continue"; istal$
       errret% = -1
       RETURN
      ELSE
       irdnum% = irdnum% + rodtst%(tstlt% - 64)
     END IF
   NEXT ij%
 END IF
REM  PRINT "irdnum% "; irdnum%
REM  INPUT "hit reurn to continue"; istal$
RETURN


Place:
pagnum% = 1
777 CLS 0
pgstrt% = 44 * (pagnum% - 1)
pages% = INT((irepct% - 1) / 44) + 1
IF pages% = 1 THEN
  PRINT "           Placename Information   "
 ELSE
  PRINT "           Placename Information   Page "; pagnum%; " of "; pages%
END IF
pgcrct% = irepct% - pgstrt%
IF pgcrct% < 23 THEN
  FOR jk% = pgstrt% + 1 TO irepct%
    plnm$ = HEX$(jk% - 1)

  PRINT USING "\\  \                            \"; plnm$; newnam$(jk%)
REM                 3456789 123456789 123456789
  NEXT jk%
 ELSE
   IF pgcrct% > 44 THEN
     jend1% = pgstrt% + 22
    ELSE
     jend1% = irepct% - 22
   END IF
  FOR jk% = pgstrt% + 1 TO jend1%
    plnm$ = HEX$(jk% - 1)
    plnm2$ = HEX$(jk% + 22 - 1)

  PRINT USING "\\  \                            \    \\  \                            \"; plnm$; newnam$(jk%); plnm2$; newnam$(jk% + 22)
  NEXT jk%
  IF jend1% = pgstrt% + 22 THEN
    GOTO 773
   ELSE
    FOR jk% = jend1% + 1 TO pgstrt% + 22
     plnm$ = HEX$(jk% - 1)
  PRINT USING "\\  \                            \"; plnm$; newnam$(jk%)
    NEXT jk%
  END IF
773 dummy = 0

END IF
776 dummy = 0
IF pages% = 1 THEN
  INPUT " existing name# (H), N for new name, R (no change)  "; istal$
 ELSE
  INPUT " existing name# (H), N for new name, R (no change), Px for page(x)   "; istal$
END IF
IF LEFT$(istal$, 1) = "R" OR LEFT$(istal$, 1) = "r" THEN
  RETURN
 ELSE
END IF

IF LEFT$(istal$, 1) = "N" OR LEFT$(istal$, 1) = "n" THEN
REM new entry
779  CLS 0
  PRINT "inut new placename  28 character limit "
  PRINT "         1         2"
  PRINT "1234567890123456789012345678"
  INPUT ; "", tmpnam$
  tmplen% = LEN(tmpnam$)
  IF tmplen% = 0 OR tmplen% > 28 THEN
    PRINT "error in name input"
    INPUT " hit return to continue"; istal$
    GOTO 779
   ELSE
    CLS 0
    PRINT "old place name => "; prt5$
    PRINT "new place name => "; tmpnam$
    INPUT "confirm new entry y/n "; istal$
    IF LEFT$(istal$, 1) = "n" OR LEFT$(istal$, 1) = "N" THEN
      GOTO 777
     ELSE
      irepct% = irepct% + 1
      newnam$(irepct%) = tmpnam$
      map%(indx%, 5) = irepct% - 1
      RETURN
    END IF
  END IF

 ELSE
END IF
IF LEFT$(istal$, 1) = "p" OR LEFT$(istal$, 1) = "P" THEN
REM goto page
  IF LEN(istal$) <> 2 THEN
    PRINT "error in Px input "
    INPUT "hit return to continue "; istal$
    GOTO 777
   ELSE
  END IF
  conv$ = MID$(istal$, 2, 1)
REM  PRINT "conv$ = "; conv$
  tcon% = ASC(conv$)
REM  PRINT "tcon% "; tcon%
  IF tcon% < 49 OR tcon% > 57 THEN
    PRINT "error in selecting page"
    INPUT "hit return to continue "; istal$
    GOTO 777
   ELSE
    tmpnum% = tcon% - 48
    IF tmpnum% > pages% THEN
      PRINT " page selected "; tmpnum%; "   is greater than # of pages "; pages%
      INPUT "hit return to continue "; istal$
     ELSE
      pagnum% = tmpnum%
   END IF
    GOTO 777
  END IF
 ELSE
END IF

REM number
hexin$ = istal$
testlen% = LEN(hexin$)
IF testlen% > 2 THEN
  PRINT "  entry more than two characters"
  INPUT " hit return to continue "; istal$
  GOTO 777
 ELSE
  GOSUB Hexprt
  IF iprt% < 0 OR iprt% > irepct% - 1 THEN
    PRINT " entry outside of valid range"
    INPUT " hit return to enter "; istal$
    GOTO 777
   ELSE
    CLS 0
    tmpnam$ = newnam$(iprt% + 1)
    PRINT "old place name => "; prt5$
    PRINT "new place name => "; tmpnam$
    INPUT "confirm new entry y/n "; istal$
    IF LEFT$(istal$, 1) = "n" OR LEFT$(istal$, 1) = "N" THEN
      GOTO 777
     ELSE
REM      PRINT " hexin$ "; hexin$
REM      PRINT " number "; iprt%
      map%(indx%, 5) = iprt%
    END IF
  END IF
END IF

RETURN


